import evdev 
from camilladsp import CamillaConnection
import sys

try:
    port = int(sys.argv[1])
except:
    print("Usage: Start CamillaDSP with the websocket server enabled:")
    print("> camilladsp -p4321 yourconfig.yml")
    print("Then run this script to print some parameters from the active config.")
    print("> python get_config.py 4321")
    sys.exit()

cdsp = CamillaConnection("127.0.0.1", port)
cdsp.connect()
  
def main():

  flirc=evdev.InputDevice('/dev/input/by-id/usb-flirc.tv_flirc-if01-event-kbd')
  flirc.grab()
  
  cdspvolume = cdsp.get_volume()
      
  for event in flirc.read_loop():
       if event.type == evdev.ecodes.EV_KEY:
            attrib = evdev.categorize(event)
            if attrib.keystate == 1:
                if attrib.keycode == 'KEY_DOWN':
                    if cdspvolume -1 >= -100:
                        cdsp.set_volume(cdspvolume - 1)
                        cdspvolume = cdsp.get_volume()
                    elif cdspvolume -1 <= -100:
                        cdsp.set_volume(-100)
                        cdspvolume = cdsp.get_volume()
            
                elif attrib.keycode == 'KEY_UP':
                    if cdspvolume + 1 < 0:
                        cdsp.set_volume(cdspvolume + 1)
                        cdspvolume = cdsp.get_volume()
        
                    elif cdspvolume + 1 >= 0:
                        cdsp.set_volume(0)
                        cdspvolume = cdsp.get_volume()
                        
            elif attrib.keystate == 2:
                if attrib.keycode == 'KEY_DOWN':
                    if cdspvolume -1 >= -100:
                        cdsp.set_volume(cdspvolume - 1)
                        cdspvolume = cdsp.get_volume()
                    elif cdspvolume -1 <= -100:
                        cdsp.set_volume(-100)
                        cdspvolume = cdsp.get_volume()
            
                elif attrib.keycode == 'KEY_UP':
                    if cdspvolume + 1 < 0:
                        cdsp.set_volume(cdspvolume + 1)
                        cdspvolume = cdsp.get_volume()
        
                    elif cdspvolume + 1 >= 0:
                        cdsp.set_volume(0)
                        cdspvolume = cdsp.get_volume()
            
 
if __name__ == '__main__':
 
  try:
    main()
  except KeyboardInterrupt:
    pass
